Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QKeySequence

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.gui.QKeySequence

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable, java.lang.Comparable

    public class QKeySequence

extends QtJambiObject
implements java.lang.Comparable, java.lang.Cloneable

The `QKeySequence` class encapsulates a key sequence as used by shortcuts. In its most common form, a key sequence describes a combination of keys that must be used together to perform some action. Key sequences are used with `QAction` objects to specify which keyboard shortcuts can be used to trigger actions.

Key sequences can be constructed for use as keyboard shortcuts in three different ways:

- For standard shortcuts, a `standard key` can be used to request the platform-specific key sequence associated with each shortcut.
- For custom shortcuts, human-readable strings such as "Ctrl+X" can be used, and these can be translated into the appropriate shortcuts for users of different languages. Translations are made in the "`QShortcut`" context.
- For hard-coded shortcuts, integer key codes can be specified with a combination of values defined by the `Qt::Key` and `Qt::Modifier` enum values. Each key code consists of a single `Qt::Key` value and zero or more modifiers, such as `Qt::SHIFT` , `Qt::CTRL` , `Qt::ALT` and `Qt::META` .

For example, Ctrl P might be a sequence used as a shortcut for printing a document, and can be specified in any of the following ways:

        new QKeySequence(QKeySequence.StandardKey.Print);
        new QKeySequence(tr("Ctrl+P"));
        new QKeySequence(tr("Ctrl+p"));
        new QKeySequence(Qt.Modifier.CTRL.value() + Qt.Key.Key_P.value());

Note that, for letters, the case used in the specification string does not matter. In the above examples, the user does not need to hold down the Shift key to activate a shortcut specified with "Ctrl+P". However, for other keys, the use of Shift as an unspecified extra modifier key can lead to confusion for users of an application whose keyboards have different layouts to those used by the developers. See the `Keyboard Layout Issues` section below for more details.

It is preferable to use standard shortcuts where possible. When creating key sequences for non-standard shortcuts, you should use human-readable strings in preference to hard-coded integer values.

`QKeySequence` objects can be cast to a QString to obtain a human-readable translated version of the sequence. Similarly, the `toString()` function produces human-readable strings for use in menus. On Mac OS X, the appropriate symbols are used to describe keyboard shortcuts using special keys on the Macintosh keyboard.

An alternative way to specify hard-coded key codes is to use the Unicode code point of the character; for example, 'A' gives the same key sequence as `Qt::Key_A` .

Note: On Mac OS X, references to "Ctrl", `Qt::CTRL` , `Qt::Control` and `Qt::ControlModifier` correspond to the Command keys on the Macintosh keyboard, and references to "Meta", `Qt::META` , `Qt::Meta` and `Qt::MetaModifier` correspond to the Control keys. Developers on Mac OS X can use the same shortcut descriptions across all platforms, and their applications will automatically work as expected on Mac OS X.

## Standard Shortcuts

`QKeySequence` defines many `StandardKey` standard keyboard shortcuts to reduce the amount of effort required when setting up actions in a typical application. The table below shows some common key sequences that are often used for these standard shortcuts by applications on four widely-used platforms. Note that on Mac OS X, the Ctrl value corresponds to the Command keys on the Macintosh keyboard, and the Meta value corresponds to the Control keys.

`StandardKey` | Windows | Mac OS X | KDE | GNOME
--- | --- | --- | --- | ---
`HelpContents` | F1 | Ctrl+? | F1 | F1
`WhatsThis` | Shift+F1 | Shift+F1 | Shift+F1 | Shift+F1
Open | Ctrl+O | Ctrl+O | Ctrl+O | Ctrl+O
Close | Ctrl+F4, Ctrl+W | Ctrl+W, Ctrl+F4 | Ctrl+W | Ctrl+W
Save | Ctrl+S | Ctrl+S | Ctrl+S | Ctrl+S
New | Ctrl+N | Ctrl+N | Ctrl+N | Ctrl+N
Delete | Del | Del, Meta+D | Del, Ctrl+D | Del, Ctrl+D
Cut | Ctrl+X, Shift+Del | Ctrl+X | Ctrl+X, F20, Shift+Del | Ctrl+X, F20, Shift+Del
Copy | Ctrl+C, Ctrl+Ins | Ctrl+C | Ctrl+C, F16, Ctrl+Ins | Ctrl+C, F16, Ctrl+Ins
Paste | Ctrl+V, Shift+Ins | Ctrl+V | Ctrl+V, F18, Shift+Ins | Ctrl+V, F18, Shift+Ins
Undo | Ctrl+Z, Alt+Backspace | Ctrl+Z | Ctrl+Z, F14 | Ctrl+Z, F14
Redo | Ctrl+Y, Shift+Ctrl+Z, Alt+Shift+Backspace | Ctrl+Shift+Z, Ctrl+Y | Ctrl+Shift+Z | Ctrl+Shift+Z
Back | Alt+Left, Backspace | Ctrl+[ | Alt+Left | Alt+Left
Forward | Alt+Right, Shift+Backspace | Ctrl+] | Alt+Right | Alt+Right
Refresh | F5 | F5 | F5 | Ctrl+R, F5
`ZoomIn` | Ctrl+Plus | Ctrl+Plus | Ctrl+Plus | Ctrl+Plus
`ZoomOut` | Ctrl+Minus | Ctrl+Minus | Ctrl+Minus | Ctrl+Minus
Print | Ctrl+P | Ctrl+P | Ctrl+P | Ctrl+P
`AddTab` | Ctrl+T | Ctrl+T | Ctrl+Shift+N, Ctrl+T | Ctrl+T
`NextChild` | Ctrl+Tab, Forward, Ctrl+F6 | Ctrl+}, Forward, Ctrl+Tab | Ctrl+Tab, Forward, Ctrl+Comma | Ctrl+Tab, Forward
`PreviousChild` | Ctrl+Shift+Tab, Back, Ctrl+Shift+F6 | Ctrl+{, Back, Ctrl+Shift+Tab | Ctrl+Shift+Tab, Back, Ctrl+Period | Ctrl+Shift+Tab, Back
Find | Ctrl+F | Ctrl+F | Ctrl+F | Ctrl+F
`FindNext` | F3, Ctrl+G | Ctrl+G | F3 | Ctrl+G, F3
`FindPrevious` | Shift+F3, Ctrl+Shift+G | Ctrl+Shift+G | Shift+F3 | Ctrl+Shift+G, Shift+F3
Replace | Ctrl+H | (none) | Ctrl+R | Ctrl+H
`SelectAll` | Ctrl+A | Ctrl+A | Ctrl+A | Ctrl+A
Bold | Ctrl+B | Ctrl+B | Ctrl+B | Ctrl+B
Italic | Ctrl+I | Ctrl+I | Ctrl+I | Ctrl+I
Underline | Ctrl+U | Ctrl+U | Ctrl+U | Ctrl+U
`MoveToNextChar` | Right | Right | Right | Right
`MoveToPreviousChar` | Left | Left | Left | Left
`MoveToNextWord` | Ctrl+Right | Alt+Right | Ctrl+Right | Ctrl+Right
`MoveToPreviousWord` | Ctrl+Left | Alt+Left | Ctrl+Left | Ctrl+Left
`MoveToNextLine` | Down | Down | Down | Down
`MoveToPreviousLine` | Up | Up | Up | Up
`MoveToNextPage` | `PgDown` | `PgDown`, Alt+`PgDown`, Meta+Down, Meta+`PgDown` | `PgDown` | `PgDown`
`MoveToPreviousPage` | `PgUp` | `PgUp`, Alt+`PgUp`, Meta+Up, Meta+`PgUp` | `PgUp` | `PgUp`
`MoveToStartOfLine` | Home | Ctrl+Left, Meta+Left | Home | Home
`MoveToEndOfLine` | End | Ctrl+Right, Meta+Right | End | End
`MoveToStartOfBlock` | (none) | Alt+Up, Meta+A | (none) | (none)
`MoveToEndOfBlock` | (none) | Alt+Down, Meta+E | (none) | (none)
`MoveToStartOfDocument` | Ctrl+Home | Ctrl+Up, Home | Ctrl+Home | Ctrl+Home
`MoveToEndOfDocument` | Ctrl+End | Ctrl+Down, End | Ctrl+End | Ctrl+End
`SelectNextChar` | Shift+Right | Shift+Right | Shift+Right | Shift+Right
`SelectPreviousChar` | Shift+Left | Shift+Left | Shift+Left | Shift?left
`SelectNextWord` | Ctrl+Shift+Right | Alt+Shift+Right | Ctrl+Shift+Right | Ctrl+Shift+Right
`SelectPreviousWord` | Ctrl+Shift+Left | Alt+Shift+Left | Ctrl+Shift+Left | Ctrl+Shift+Left
`SelectNextLine` | Shift+Down | Shift+Down | Shift+Down | Shift+Down
`SelectPreviousLine` | Shift+Up | Shift+Up | Shift+Up | Shift+Up
`SelectNextPage` | Shift+`PgDown` | Shift+`PgDown` | Shift+`PgDown` | Shift+`PgDown`
`SelectPreviousPage` | Shift+`PgUp` | Shift+`PgUp` | Shift+`PgUp` | Shift+`PgUp`
`SelectStartOfLine` | Shift+Home | Ctrl+Shift+Left | Shift+Home | Shift+Home
`SelectEndOfLine` | Shift+End | Ctrl+Shift+Right | Shift+End | Shift+End
`SelectStartOfBlock` | (none) | Alt+Shift+Up | (none) | (none)
`SelectEndOfBlock` | (none) | Alt+Shift+Down | (none) | (none)
`SelectStartOfDocument` | Ctrl+Shift+Home | Ctrl+Shift+Up, Shift+Home | Ctrl+Shift+Home | Ctrl+Shift+Home
`SelectEndOfDocument` | Ctrl+Shift+End | Ctrl+Shift+Down, Shift+End | Ctrl+Shift+End | Ctrl+Shift+End
`DeleteStartOfWord` | Ctrl+Backspace | Alt+Backspace | Ctrl+Backspace | Ctrl+Backspace
`DeleteEndOfWord` | Ctrl+Del | (none) | Ctrl+Del | Ctrl+Del
`DeleteEndOfLine` | (none) | (none) | Ctrl+K | Ctrl+K

Note that, since the key sequences used for the standard shortcuts differ between platforms, you still need to test your shortcuts on each platform to ensure that you do not unintentionally assign the same key sequence to many actions.

## Keyboard Layout Issues

Many key sequence specifications are chosen by developers based on the layout of certain types of keyboard, rather than choosing keys that represent the first letter of an action's name, such as Ctrl S ("Ctrl+S") or Ctrl C ("Ctrl+C"). Additionally, because certain symbols can only be entered with the help of modifier keys on certain keyboard layouts, key sequences intended for use with one keyboard layout may map to a different key, map to no keys at all, or require an additional modifier key to be used on different keyboard layouts.

For example, the shortcuts, Ctrl plus and Ctrl minus, are often used as shortcuts for zoom operations in graphics applications, and these may be specified as "Ctrl++" and "Ctrl+-" respectively. However, the way these shortcuts are specified and interpreted depends on the keyboard layout. Users of Norwegian keyboards will note that the + and - keys are not adjacent on the keyboard, but will still be able to activate both shortcuts without needing to press the Shift key. However, users with British keyboards will need to hold down the Shift key to enter the + symbol, making the shortcut effectively the same as "Ctrl+Shift+=".

Although some developers might resort to fully specifying all the modifiers they use on their keyboards to activate a shortcut, this will also result in unexpected behavior for users of different keyboard layouts.

For example, a developer using a British keyboard may decide to specify "Ctrl+Shift+=" as the key sequence in order to create a shortcut that coincidentally behaves in the same way as Ctrl plus. However, the = key needs to be accessed using the Shift key on Norwegian keyboard, making the required shortcut effectively Ctrl Shift Shift = (an impossible key combination).

As a result, both human-readable strings and hard-coded key codes can both be problematic to use when specifying a key sequence that can be used on a variety of different keyboard layouts. Only the use of `standard shortcuts` guarantees that the user will be able to use the shortcuts that the developer intended.

Despite this, we can address this issue by ensuring that human-readable strings are used, making it possible for translations of key sequences to be made for users of different languages. This approach will be successful for users whose keyboards have the most typical layout for the language they are using.

## GNU Emacs Style Key Sequences

Key sequences similar to those used in GNU Emacs, allowing up to four key codes, can be created by using the multiple argument constructor, or by passing a human-readable string of comma-separated key sequences.

For example, the key sequence, Ctrl X followed by Ctrl C, can be specified using either of the following ways:

        new QKeySequence(tr("Ctrl+X, Ctrl+C"));
        new QKeySequence(Qt.Modifier.CTRL.value() + Qt.Key.Key_X.value(),
                         Qt.Modifier.CTRL.value() + Qt.Key.Key_C.value());

See also:
  `QShortcut`.

Nested Class Summary
`static class` | `QKeySequence.SequenceFormat`
`static class` | `QKeySequence.SequenceMatch`
`static class` | `QKeySequence.StandardKey` This enum represent standard key bindings.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Constructor Summary
`QKeySequence()` Constructs an empty key sequence.
`QKeySequence(int k1)` Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.
`QKeySequence(int k1, int k2)` Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.
`QKeySequence(int k1, int k2, int k3)` Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.
`QKeySequence(int k1, int k2, int k3, int k4)` Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.
`QKeySequence(QKeySequence.StandardKey key)` Constructs a `QKeySequence` object for the given `key`.
`QKeySequence(QKeySequence ks)` Copy constructor.
`QKeySequence(java.lang.String key)` Creates a key sequence from the `key` string.

Method Summary
`int` | `at(int i)` Returns the key at index `i` in this key sequence.
`QKeySequence` | `clone()` This method is reimplemented for internal reasons
`int` | `count()` Returns the number of keys in the key sequence.
`static QKeySequence` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QKeySequence instance pointed to by `nativePointer`.
`static QKeySequence` | `fromString(java.lang.String str)` Return a `QKeySequence` from the string `str` based on `format`.
`static QKeySequence` | `fromString(java.lang.String str, QKeySequence.SequenceFormat format)` Return a `QKeySequence` from the string `str` based on `format`.
`boolean` | `isEmpty()` Returns true if the key sequence is empty; otherwise returns false.
`static java.util.List` | `keyBindings(QKeySequence.StandardKey key)` Returns a list of key bindings for the given `key`.
`QKeySequence.SequenceMatch` | `matches(QKeySequence seq)` Matches the sequence with `seq`.
`static QKeySequence` | `mnemonic(java.lang.String text)` Returns the shortcut key sequence for the mnemonic in `text`, or an empty key sequence if no mnemonics are found.
`static QNativePointer` | `nativePointerArray(QKeySequence[] array)` This function returns a QNativePointer that is pointing to the specified QKeySequence array.
`void` | `readFrom(QDataStream out)` Reads a QKeySequence
`int` | `toInt()` For backward compatibility.
`java.lang.String` | `toString()` Returns a string representation of the `this QKeySequence`.
`java.lang.String` | `toString(QKeySequence.SequenceFormat format)` Returns a string representation of the `com.trolltech.qt.gui.QKeySequence$SequenceFormat` argument.
`void` | `writeTo(QDataStream in)` Writes thisQKeySequence

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.lang.Comparable
`compareTo`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QKeySequence

    public QKeySequence()

  Constructs an empty key sequence.

### QKeySequence

    public QKeySequence(QKeySequence.StandardKey key)

  Constructs a `QKeySequence` object for the given `key`. The result will depend on the currently running platform.

  The resulting object will be based on the first element in the list of key bindings for the `key`.

### QKeySequence

    public QKeySequence(QKeySequence ks)

  Copy constructor. Makes a copy of `keysequence`.

### QKeySequence

    public QKeySequence(java.lang.String key)

  Creates a key sequence from the `key` string. For example "Ctrl+O" gives CTRL+'O'. The strings "Ctrl", "Shift", "Alt" and "Meta" are recognized, as well as their translated equivalents in the "`QShortcut`" context (using QObject::tr()).

  Up to four key codes may be entered by separating them with commas, e.g. "Alt+X,Ctrl+S,Q".

  This constructor is typically used with tr(), so that shortcut keys can be replaced in translations:

              QMenu file = new QMenu(this);
              file.addAction(tr("pen..."), this, "open()",
                                new QKeySequence(tr("Ctrl+O", "File|Open")));

  Note the "File|Open" translator comment. It is by no means necessary, but it provides some context for the human translator.

### QKeySequence

    public QKeySequence(int k1,
                        int k2,
                        int k3)

  Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.

  The key codes are listed in `Qt::Key` and can be combined with modifiers (see `Qt::Modifier` ) such as `Qt::SHIFT` , `Qt::CTRL` , `Qt::ALT` , or `Qt::META` .

### QKeySequence

    public QKeySequence(int k1,
                        int k2)

  Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.

  The key codes are listed in `Qt::Key` and can be combined with modifiers (see `Qt::Modifier` ) such as `Qt::SHIFT` , `Qt::CTRL` , `Qt::ALT` , or `Qt::META` .

### QKeySequence

    public QKeySequence(int k1)

  Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.

  The key codes are listed in `Qt::Key` and can be combined with modifiers (see `Qt::Modifier` ) such as `Qt::SHIFT` , `Qt::CTRL` , `Qt::ALT` , or `Qt::META` .

### QKeySequence

    public QKeySequence(int k1,
                        int k2,
                        int k3,
                        int k4)

  Constructs a key sequence with up to 4 keys `k1`, `k2`, `k3` and `k4`.

  The key codes are listed in `Qt::Key` and can be combined with modifiers (see `Qt::Modifier` ) such as `Qt::SHIFT` , `Qt::CTRL` , `Qt::ALT` , or `Qt::META` .

Method Detail

### count

    public final int count()

  Returns the number of keys in the key sequence. The maximum is 4.

### isEmpty

    public final boolean isEmpty()

  Returns true if the key sequence is empty; otherwise returns false.

### matches

    public final QKeySequence.SequenceMatch matches(QKeySequence seq)

  Matches the sequence with `seq`. Returns `ExactMatch` if successful, `PartialMatch` if `seq` matches incompletely, and `NoMatch` if the sequences have nothing in common. Returns `NoMatch` if `seq` is shorter.

### writeTo

    public final void writeTo(QDataStream in)

  Writes thisQKeySequence

### readFrom

    public final void readFrom(QDataStream out)

  Reads a QKeySequence

### toString

    public final java.lang.String toString()

  Returns a string representation of the `this QKeySequence`.

  Overrides:
    `toString` in class `java.lang.Object`

### toString

    public final java.lang.String toString(QKeySequence.SequenceFormat format)

  Returns a string representation of the `com.trolltech.qt.gui.QKeySequence$SequenceFormat` argument.

### fromString

    public static QKeySequence fromString(java.lang.String str)

  Return a `QKeySequence` from the string `str` based on `format`.

See also:
  `toString()`.

### fromString

    public static QKeySequence fromString(java.lang.String str,
                                          QKeySequence.SequenceFormat format)

  Return a `QKeySequence` from the string `str` based on `format`.

See also:
  `toString()`.

### keyBindings

    public static java.util.List keyBindings(QKeySequence.StandardKey key)

  Returns a list of key bindings for the given `key`. The result of calling this function will vary based on the target platform. The first element of the list indicates the primary shortcut for the given platform. If the result contains more than one result, these can be considered alternative shortcuts on the same platform for the given `key`.

### mnemonic

    public static QKeySequence mnemonic(java.lang.String text)

  Returns the shortcut key sequence for the mnemonic in `text`, or an empty key sequence if no mnemonics are found.

  For example, mnemonic("E&xit") returns `Qt::ALT+Qt::Key_X`, mnemonic("&Quit") returns `ALT+Key_Q`, and mnemonic("Quit") returns an empty `QKeySequence`.

  We provide a list of common mnemonics in English. At the time of writing, Microsoft and Open Group do not appear to have issued equivalent recommendations for other languages.

See also:
  qt_set_sequence_auto_mnemonic().

### fromNativePointer

    public static QKeySequence fromNativePointer(QNativePointer nativePointer)

  This method returns the QKeySequence instance pointed to by `nativePointer`.

### nativePointerArray

    public static QNativePointer nativePointerArray(QKeySequence[] array)

  This function returns a QNativePointer that is pointing to the specified QKeySequence array.

### toInt

    public final int toInt()

  For backward compatibility. returns the first keycode as integer. If the key sequence is empty, 0 is returned.

### at

    public final int at(int i)

  Returns the key at index `i` in this key sequence.

### clone

    public QKeySequence clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD